#include <LiquidCrystal_I2C.h>//библиотека для работы с ЛСД экраном
#include <EEPROM.h>// библиотека для работы с памятью Ардуино
using namespace std;
LiquidCrystal_I2C lcd(0x27,16,2);
const int PIN_BUTTON = 2;
int zero = 0, sensor, FTU, buttonState = 0,first_coeff_addr = 2,second_coeff_addr = 10,coeff_confirm=18;
//first_coeff_addr,second_coeff_addr ,coeff_confirm - адреса переменных EEPROM 
//первого и второго коэффициента для формулы,а также подтверждение что коэффициенты в памяти
double sensorValues[3];
int SI_TABLE[3];
int nomer_calibr = 0;
double a_coeff;
double b_coeff;
void setup() {
 Serial.begin(9600);
 pinMode(PIN_BUTTON, INPUT_PULLUP);//использования подтягивающий резистор
 analogReference(DEFAULT);
 SI_TABLE[0]=0;
 SI_TABLE[1]=40;
 SI_TABLE[2] = 100;
 lcd.init();
 lcd.backlight();
 int coeff_confirm2=0; //можно заменить int на double/float (и вместо шанса на ошибку 1/256 будет 1/6566)
 //,но сократится колличество возможных перезаписи
 int count1 = 0;
 EEPROM.get(coeff_confirm, coeff_confirm2);//берем значение из памяти
 if(coeff_confirm2 == 1)//проверяем есть ли в памяти значения нужное
 {//если есть то берем коэффициенты из памяти
   EEPROM.get(first_coeff_addr, a_coeff);
   EEPROM.get(second_coeff_addr, b_coeff);   
 }
 else{//если нет,то делаем калибровку
   while(count1<3){
      lcd.println("wait to calibration");
      int buttonState = digitalRead(PIN_BUTTON);
      delay(100);
     if (buttonState == 0) {
      lcd.clear();
       lcd.print("CALIBRATING ");
       lcd.print(nomer_calibr);
       Calibr();
       count1++;
       delay(1000);
    } 
    lcd.clear();
  }
  EEPROM.put(coeff_confirm, 1);//вписываем в память,что данные в памяти есть
 }
}
void loop() {
  
  sensor = 0;
  lcd.clear();

  buttonState = digitalRead(PIN_BUTTON);//считываем значения кнопки
  if (buttonState == 0) {//если нажата кнопка то производится калибровка
   lcd.print("CALIBRATING ");
   lcd.print(nomer_calibr);
   Calibr();
   delay(1000);
  }
  lcd.clear();
  perevod_formuli();
  delay(300);
}

void Calibr(){
  sensorValues[nomer_calibr] = analogRead(A0);
  nomer_calibr++;
  if(nomer_calibr>2){//если калибровок больше 3 то производится сброс счетчика до нуля
    nomer_calibr = 0;
    Coeff();//и высчитываются коэффициенты
  }
}

void Coeff()
{
  int n =3;//используется формулы линейной регрессии
  double sumx = 0,sumxkvadr=0,sumy=0,sumxy=0;
  for(int i = 0;i<3;i++){
    sumy += sensorValues[i];
    sumx += SI_TABLE[i];
    sumxy += SI_TABLE[i]*sensorValues[i];
    sumxkvadr += SI_TABLE[i]*SI_TABLE[i];
  }
  a_coeff= (sumx*sumy - 3*sumxy)/(sumx*sumx-n*sumxkvadr);
  b_coeff = (sumx*sumxy-sumxkvadr*sumy)/(sumx*sumx-n*sumxkvadr);
  EEPROM.put(first_coeff_addr, a_coeff);//кладется в память коэффициент1
  EEPROM.put(second_coeff_addr, b_coeff);//кладется в память коэффициент1
}

void perevod_formuli(){
  int normal_chislo = 0;
  normal_chislo = (analogRead(A0)-b_coeff)/a_coeff;//перевод из УЕ датчика в ЕМФ
  lcd.print(normal_chislo);//вывод значения на экран
  delay(1000);
}
